<template>
    <div>
      <div class="main">
      <h1> <img src=".././assets/cadastro.jpg" alt="cadastro" style="width: 100px"> <b>Cadastro Motorista</b></h1>
      <br>

        <!-- <ul>
          <li v-for="(erro, index) of errors" :key="index">
            campo <b> {{ erro.field }} </b> - {{ erro.defaultMessage }}
          </li>
        </ul> -->

      <form @submit.prevent="salvar">

        <div class="form-row">
          <div class="form-group col-md-6">
            <label for="inputName4">Nome Completo</label>
            <input type="name" class="form-control" id="inputName4" placeholder="Nome" v-model='motorista.nome'>
          </div>
          <div class="form-group col-md-3">
            <label for="inputCpf4">CPF</label>
            <input type="text" class="form-control" id="inputCpf4" placeholder="CPF" maxlength="11" v-model='motorista.cpf'>
          </div>
          <div class="form-group col-md-3">
            <label for="inputID4">RG</label>
            <input type="text" class="form-control" id="inputID4" placeholder="RG" maxlength="9" v-model='motorista.rg'>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-md-4">
            <label for="inputAddress">Endereço</label>
            <input type="text" class="form-control" id="inputAddress" placeholder="Rua x" v-model='motorista.endereco'>
          </div>
          <div class="form-group col-md-3">
              <label for="inputCity">Cidade</label>
              <input type="text" class="form-control" id="inputCity" v-model='motorista.cidade'>
            </div>
            <div class="form-group col-md-3">
              <label for="inputDisp">Disponibilidade</label>
              <input type="text" class="form-control" id="inputDisp" v-model='motorista.disponivel'>
            </div>
            </div>
        <div class="form-row">
            <div class="form-group col-md-3">
                <label for="inputBirth">Data de Nascimento</label>
                <input type="date" class="form-control" id="inputBirth" placeholder="Telefone" v-model='motorista.nascimento'>
            </div>
            <div class="form-group col-md-3">
                <label for="inputFone">Telefone</label>
                <input type="text" class="form-control" id="inputFone" placeholder="Telefone" maxlength="11" v-model='motorista.telefone'>
            </div>
          <div class="form-group col-md-3">
            <label for="inputCategory">Categoria</label>
            <input type="text" id="inputCategory" class="form-control" v-model='motorista.categoria'>
          </div>
          <div class="form-group col-md-3">
            <label for="inputExpirate">Data de Vencimento</label>
            <input type="date" class="form-control" id="inputExpirate" placeholder="Telefone" v-model='motorista.vencdocs'>
          </div>
        </div>
        <div class='row'>
          <div class='form-group col-md-6'>
            <label for="inputCNH">CNH</label>
            <input type="text" class="form-control" id="inputCNH" placeholder="CNH" maxlength="15" v-model='motorista.cnh'>
          </div>
          <div class='form-group col-md-6'>
            <label for="inputObs">Observação</label>
            <input type="text" class="form-control" id="inputObs" placeholder="Observação" maxlength="250" v-model='motorista.obs'>
          </div>
        </div>

        <button class="btn btn-primary">Enviar</button>
      </form>
      <div style='margin: 2%'>
        <h1> <img src=".././assets/motorista.png" alt="cadastro" style="width: 100px;"> Listagem de Motoristas </h1>
        <!-- <router-link to='/motorista_add'>
            <button type="button" class="btn btn-primary">Cadastrar</button>
        </router-link> -->
        </div>
        
    <table class="table">
        <thead class="bg-success">
          <tr>
            <th>ID</th>
            <th>Nome</th>
            <th>Disponibilidade</th>
            <th>Ações</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="motorista of motoristas" :key="motorista.id">
            <td>{{ motorista.id }}</td>
            <td>{{ motorista.nome }}</td>
            <td>{{ motorista.disponivel }}</td>
            <td> <button type="button" @click="remover(motorista)" class="btn btn-danger">Deletar</button>
            <button type="button" @click="editar(motorista)" class="btn btn-info" style="margin-left: 2%">Editar</button> </td>
          </tr>
        </tbody>
    </table>
    </div>
    </div>
</template>


<script>

  import Motorista from '../services/motoristas'
  import axios from 'axios'
  import { httpGet } from '../services/config'

  export default {

    data() {
      return {
        motorista: {
          "id": '',
          "viagem": null,
          "nome": '',
          "cpf": '',
          "rg": '',
          "disponivel": '',
          "nascimento": '',
          "telefone": '',
          "endereco": '',
          "cidade": '',
          "categoria": '',
          "obs": '',
          "cnh": '',
          "vencdocs": ''
        },
        motoristas: [],
        errors: [],
      }
    },

    mounted() {
      this.listar()
    },

    methods:{

        listar() {
          Motorista.listar().then(resposta => {
          this.motoristas = resposta.data
        })
      },

      salvar() {
        console.log("Motorista_id", this.motorista.id)
        if(!this.motorista.id) {
          Motorista.salvar(this.motorista).then(resposta => {
            console.log('Salvo com sucesso!')
            this.motorista = {}
            this.errors = []
            this.listar()
          }).catch(e => {
            this.errors = e.response.data.errors
            this.$router.push({ path:('/Erro'), params: { errors: this.errors } })            
          })
        } else {
          Motorista.atualizar(this.motorista).then(resposta => {
            this.motorista = {}
            alert('Motorista Atualizado!')
            this.errors = []
            this.listar()
          }).catch(e => {
            this.errors = e.response.data.errors
          })
        }

      },

      editar(motorista) {
        this.motorista = motorista
      },

      remover(motorista) {

        if (confirm('Deseja excluir o motorista?')) {
        axios.delete(httpGet() + '/motoristas/' + motorista.id).then(resposta => {
          this.errors = []
          this.listar()
        }).catch(e => {
            this.erros = e.response.data.errors
          })
        }
      }
    }
  }
</script>